var curryLast, getLeafTextNodes, htmlColl2Arr, isInputBox, isTextNode, isValidBaseNode, replaceAllFromNode, replaceAllInPage, replaceRecurFromNode, watchFutureNodes,
  slice = [].slice;

isInputBox = function(node) {
  var ref;
  if (node == null) {
    return false;
  } else if (((ref = node.tagName) != null ? ref.toUpperCase() : void 0) === 'input') {
    return true;
  } else if (node.getAttribute == null) {
    return false;
  } else if (node.getAttribute('contenteditable')) {
    return true;
  } else if (node.getAttribute('role') === 'textbox') {
    return true;
  } else if (node.getAttribute('spellcheck')) {
    return true;
  } else {
    return false;
  }
};

isValidBaseNode = function(node, opts) {
  if (node == null) {
    return false;
  } else if (node === document) {
    return true;
  } else if ((!isInputBox(node, opts)) && (isValidBaseNode(node.parentNode))) {
    return true;
  } else {
    return false;
  }
};

isTextNode = function(node) {
  return (node != null ? node.nodeType : void 0) === 3;
};

htmlColl2Arr = function(coll) {
  return Array.prototype.slice.call(coll, 0);
};

curryLast = function() {
  var args, fn, i;
  args = 2 <= arguments.length ? slice.call(arguments, 0, i = arguments.length - 1) : (i = 0, []), fn = arguments[i++];
  return function() {
    var origArgs;
    origArgs = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    return fn.apply(null, slice.call(origArgs).concat(slice.call(args)));
  };
};

getLeafTextNodes = function(node, opts) {
  var inp;
  inp = (opts != null ? opts.inputsToo : void 0) || !(isInputBox(node));
  if (node.hasChildNodes() && inp) {
    return htmlColl2Arr(node.childNodes).map(curryLast(opts, getLeafTextNodes)).reduce(function(a, b) {
      return a.concat(b);
    });
  } else if ((isTextNode(node)) && inp) {
    return [node];
  } else {
    return [];
  }
};

replaceRecurFromNode = function(replaceFn, baseNode, opts) {
  if (!isValidBaseNode(baseNode)) {
    return [];
  }
  return getLeafTextNodes(baseNode, opts).forEach(function(node) {
    node.isReplaced = true;
    return node.data = replaceFn(node.data);
  });
};

replaceAllFromNode = function(node, replaceFn, opts) {
  var futureNodesToo, inputsToo, notNow, repeat, rplc, timeouts;
  if (opts) {
    inputsToo = opts.inputsToo, notNow = opts.notNow, repeat = opts.repeat, timeouts = opts.timeouts, futureNodesToo = opts.futureNodesToo;
  }
  rplc = function() {
    return replaceRecurFromNode(replaceFn, node, {
      inputsToo: inputsToo
    });
  };
  if (!notNow) {
    rplc();
  }
  if (timeouts != null) {
    timeouts.forEach(function(timeout) {
      return setTimeout(rplc, timeout);
    });
  }
  if (repeat) {
    setInterval(rplc, repeat);
  }
  if (futureNodesToo) {
    return watchFutureNodes(replaceFn, opts);
  }
};

replaceAllInPage = function() {
  var args;
  args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
  return replaceAllFromNode.apply(null, [document].concat(slice.call(args)));
};

watchFutureNodes = function(replaceFn, opts) {
  return new MutationObserver(function(records) {
    var extNode, i, j, len, len1, node, rec, ref;
    for (i = 0, len = records.length; i < len; i++) {
      rec = records[i];
      node = rec.target;
      switch (rec.type) {
        case 'characterData':
          if (node.isReplaced) {
            node.isReplaced = false;
          } else {
            if (isValidBaseNode(node, opts)) {
              node.data = replaceFn(node.data);
              node.isReplaced = true;
            }
          }
          break;
        case 'childList':
          ref = rec.addedNodes;
          for (j = 0, len1 = ref.length; j < len1; j++) {
            extNode = ref[j];
            replaceRecurFromNode(replaceFn, extNode, opts);
          }
      }
    }
    return null;
  });
};

module.exports = {
  replaceAllFromNode: replaceAllFromNode,
  replaceAllInPage: replaceAllInPage,
  watchFutureNodes: watchFutureNodes
};
